externalFormats {Matrix} | R Documentation

## Read and write external matrix formats

### Description

Read matrices stored in the Harwell-Boeing or MatrixMarket formats or write `sparseMatrix` objects to one of these formats.

### Usage

    readHB(file)
    readMM(file)
    writeMM(obj, file, ...)

### Arguments

`obj` | a real sparse matrix
`file` | for `writeMM` - the name of the file to be written. For `readHB` and `readMM` the name of the file to read, as a character scalar. The names of files storing matrices in the Harwell-Boeing format usually end in `".rua"` or `".rsa"`. Those storing matrices in the MatrixMarket format usually end in `".mtx"`. Alternatively, `readHB` and `readMM` accept connection objects.
`...` | optional additional arguments. Currently none are used in any methods.

### Value

The `readHB` and `readMM` functions return an object that inherits from the `"Matrix"` class. Methods for the `writeMM` generic functions usually return `NULL` and, as a side effect, the matrix `obj` is written to `file` in the MatrixMarket format (writeMM).

### Note

The Harwell-Boeing format is older and less flexible than the MatrixMarket format. The function `writeHB` was deprecated and has now been removed. Please use `writeMM` instead.

A very simple way to export small sparse matrices `S`, is to use `summary(S)` which returns a `data.frame` with columns `i`, `j`, and possibly `x`, see `summary` in `sparseMatrix-class`, and an example below.

### References

http://math.nist.gov/MatrixMarket

http://www.cise.ufl.edu/research/sparse/matrices

### Examples

    str(pores <- readMM(system.file("external/pores_1.mtx",
                                    package = "Matrix")))
    str(utm <- readHB(system.file("external/utm300.rua",
                                   package = "Matrix")))
    str(lundA <- readMM(system.file("external/lund_a.mtx",
                                    package = "Matrix")))
    str(lundA <- readHB(system.file("external/lund_a.rsa",
                                    package = "Matrix")))
    ## Not run:
    ## NOTE: The following examples take quite some time
    ## ----  even on a fast internet connection:
    if(FALSE) # the URL has been corrected, but we need an un-tar step!
    str(sm <-
     readHB(gzcon(url("http://www.cise.ufl.edu/research/sparse/RB/Boeing/msc00726.tar.gz"))))

    str(jgl009 <-
     readMM(gzcon(url("ftp://math.nist.gov/pub/MatrixMarket2/Harwell-Boeing/counterx/jgl009.mtx.gz"))))

    ## End(Not run)
    data(KNex)
    writeMM(KNex$mm, "mmMM.mtx")

    ## very simple export - in triplet format - to text file:
    data(CAex)
    s.CA <- summary(CAex)
    message("writing to ", outf <- tempfile())
    write.table(s.CA, file = outf, row.names=FALSE)
    ## and read it back -- showing off  sparseMatrix():
    dd <- read.table(outf, header=TRUE)
    mm <- do.call(sparseMatrix, dd)
    stopifnot(all.equal(mm, CAex, tol=1e-15))

[Package Matrix version 1.0-9 Index]